{% extends "base.html" %}
{%- import "common/macros/generic.html" as mg -%}


{% block head %}
    {% assets
        filters="cssrewrite, cssmin",
        output="compressed/datatables.css",
        "css/plugins/jquery.datatables.bootstrap4.min.css",
        "css/plugins/jquery.datatables.utils.css"
    %}
        {{ mg.async_css(ASSET_URL) }}
    {% endassets %}
    {% block sub_head %}{% endblock %}
{% endblock %}


{% block content_main %}
    {% if request.sub_mod %}
        {% set module_name = request.sub_mod|normalize|title %}
    {% else %}
        {% set module_name = request.mod|normalize|title %}
    {% endif %}
    <div class="row">
        <div class="col-12">
            <div class="tab-content">
                <div class="tab-pane{% if not record %} active{% endif %}" role="tabpanel" data-crud="records">
                    <div class="card" style="display: none">
                        <div class="card-header">
                            <div class="row">
                                <div class="col-12 col-md-6 col-xl-7">
                                    <nav aria-label="breadcrumb">
                                        <ol class="breadcrumb bg-transparent mb-1 mb-md-0 py-1 py-md-0 pl-1">
                                            <li class="breadcrumb-item"><a href="{{ crud.home }}">{{ module_name }}</a></li>
                                            <li class="breadcrumb-item active"> Records</li>
                                        </ol>
                                    </nav>
                                </div>
                                <div class="col-12 col-md-6 col-xl-5 text-right">
                                    <div class="row">
                                        {% block top_records_navigation %}{% endblock %}
                                        <div class="col">
                                            {% if crud.create and session.user.access_levels.permissions.get(request.mod, {}).get('create', False) %}
                                            <a href="javascript:;" class="btn btn-warning btn-sm btn-block my-2 my-md-1" data-crud-toggle="add"><i class="fa fa-fw fa-plus mr-1"></i>Add {{ module_name|singularize }}</a>
                                            {% endif %}
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <h4 class="card-title mt-1 mt-md-0"> {{ module_name|singularize }} Records</h4>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-12 col-md-4">
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <span class="input-group-text"><i class="fa fa-search"></i></span>
                                        </div>
                                        <input type="text" class="form-control" placeholder="Search..." maxlength="64" data-datatable-filter="search" />
                                    </div>
                                </div>
                                {% block datatable_filters %}{% endblock %}
                            </div>
                            <table class="table table-striped table-hover table-bordered">
                                <thead>
                                    <tr>
                                        {% for column in crud.read.many.columns %}
                                            {% if column.hidden is undefined %}
                                                <th>{{ column.label }}</th>
                                            {% endif %}
                                        {% endfor %}
                                    </tr>
                                </thead>
                            </table>
                        </div>
                    </div>
                </div>
                {% if crud.create and session.user.access_levels.permissions.get(request.mod, {}).get('create', False) %}
                <div class="tab-pane" role="tabpanel" data-crud="add">
                    <div class="card">
                        <div class="card-header">
                            <div class="row">
                                <div class="col-12 col-md-6 col-xl-7">
                                    <nav aria-label="breadcrumb">
                                        <ol class="breadcrumb bg-transparent mb-1 mb-md-0 py-1 py-md-0 pl-1">
                                            <li class="breadcrumb-item"><a href="{{crud.home }}">{{ module_name }}</a></li>
                                            <li class="breadcrumb-item active"> Add</li>
                                        </ol>
                                    </nav>
                                </div>
                                <div class="col-12 col-md-6 col-xl-5 text-right">
                                    <div class="row">
                                        <div class="col"></div>
                                        <div class="col">
                                            <a href="javascript:;" class="btn btn-danger btn-sm btn-block my-2 my-md-1" data-crud-toggle="records"><i class="fa fa-fw fa-arrow-left mr-1"></i>Go Back</a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <h4 class="card-title mt-1 mt-md-0"> Add {{ module_name|singularize }}</h4>
                        </div>
                        <div class="card-body">
                            <form method="POST" action="{{ crud.create }}">
                                {% block add_form %}{% endblock %}
                                <button type="submit" class="invisible"></button>
                            </form>
                            <span><small>Fields with (*) are required</small></span>
                        </div>
                        <div class="card-footer text-right">
                            <button type="button" class="btn btn-secondary btn-sm mr-2" data-reset-form="[data-crud='add'] form"><i class="fa fa-undo"></i> Reset</button>
                            <button type="button" class="btn btn-info btn-sm" data-submit-form="[data-crud='add'] form">Submit</button>
                        </div>
                    </div>
                </div>
                {% endif %}
                <div class="tab-pane{% if record %} active{% endif %}" role="tabpanel" data-crud="details">
                    <div class="card">
                        <div class="card-header">
                            <div class="row">
                                <div class="col-12 col-md-6 col-xl-7">
                                    <nav aria-label="breadcrumb">
                                        <ol class="breadcrumb bg-transparent mb-1 mb-md-0 py-1 py-md-0 pl-1">
                                            <li class="breadcrumb-item"><a href="{{ crud.home }}">{{ module_name }}</a></li>
                                            <li class="breadcrumb-item active"></li>
                                        </ol>
                                    </nav>
                                </div>
                                <div class="col-12 col-md-6 col-xl-5 text-right">
                                    <div class="row">
                                        <div class="col">
                                        </div>
                                        <div class="col">
                                            <a href="javascript:;" class="btn btn-danger btn-sm btn-block my-2 my-md-1" data-crud-toggle="records"><i class="fa fa-fw fa-arrow-left mr-1"></i>Go Back</a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <h4 class="card-title mt-1 mt-md-0"></h4>
                        </div>
                        <div class="card-body">
                            {% if record %}
                                <a href="javascript:;" class="invisible" data-record-id="{{ record._id }}" data-crud-toggle="details">{{ record.name }}</a>
                            {% endif %}
                            <form method="POST" action="{{ crud.update_record }}"></form>
                            <span><small>Fields with (*) are required</small></span>
                        </div>
                        <div class="card-footer text-right">
                            {% if crud.update_record and session.user.access_levels.permissions.get(request.mod, {}).get('update', False) %}
                                <button type="button" class="btn btn-secondary btn-sm mr-2" data-reset-form="[data-crud='details'] form"><i class="fa fa-undo"></i> Undo Changes</button>
                                <button type="button" class="btn btn-success btn-sm" data-submit-form="[data-crud='details'] form">Save Changes</button>
                            {% endif %}
                        </div>
                    </div>
                </div>
                <div class="tab-pane" role="tabpanel" data-crud="empty">
                    <a href="javascript:;" class="invisible" data-crud-toggle="empty"></a>
                    <div class="card">
                        <div class="card-header">
                            <div class="row">
                                <div class="col-12">
                                    <nav aria-label="breadcrumb">
                                        <ol class="breadcrumb bg-transparent mb-1 mb-md-0 py-1 py-md-0 pl-1">
                                            <li class="breadcrumb-item"><a href="{{ crud.home }}">{{ module_name }}</a></li>
                                        </ol>
                                    </nav>
                                </div>
                            </div>
                        </div>
                        <div class="card-body text-center">
                            <h2 class="h2 mt-4 mb-1">{{ module_name }}</h2>
                            <p class="text-muted">
                                {% block empty_spiel %}{% endblock %}
                            </p>
                            {% if crud.create and session.user.access_levels.permissions.get(request.mod, {}).get('create', False) %}
                            <div class="pb-4">
                                <a href="javascript:;" class="btn btn-warning" data-crud-toggle="add">Add {{ module_name|singularize }}</a>
                            </div>
                            {% endif %}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{% block scripts %}
    {% if request.sub_mod %}
        {% set module_name = request.sub_mod|normalize|title %}
    {% else %}
        {% set module_name = request.mod|normalize|title %}
    {% endif %}
    {% assets
        filters="rjsmin",
        output="compressed/datatables.js",
        "js/plugins/jquery.datatables.min.js",
        "js/plugins/jquery.datatables.bootstrap4.min.js"
    %}
        {{ mg.js(ASSET_URL) }}
    {% endassets %}
    <script>
        merge_objects($dom, {
            crud: {
                records: $('[data-crud="records"]'),
                {% if crud.create and session.user.access_levels.permissions.get(request.mod, {}).get('create', False) %}
                add: $('[data-crud="add"]'),
                {% endif %}
                details: $('[data-crud="details"]'),
                empty: $('[data-crud="empty"]')
            },
            tables: {
                records: $('[data-crud="records"] > .card > .card-body > table')
            },
            datatables: {}
        });

        $dom.document.on('click', '[data-crud-toggle]', function() {
            let $self = $(this);
            let target = $self.attr('data-crud-toggle');
            let active = $('.tab-pane.active[data-crud]').attr('data-crud');

            if (target === active) return;

            {% if request.debug %}
            console.debug('crud toggle: {0} -> {1}'.format(active, target));
            {% endif %}
            $('.tab-pane[data-crud!="{0}"]'.format(target)).removeClass('active').hide();
            $('.tab-pane[data-crud="{0}"]'.format(target)).show(250).addClass('active');
        });

        $dom.document.on('click', '[data-crud-toggle="records"]', function(e) {
            window.history.pushState('records', '{{ module_name }} Records', '/{{ module_name.lower().replace(" ", "_") }}/');
            $dom.crud.records.find('[data-datatable-filter]').resetCustom();
            {% if (crud.create and session.user.access_levels.permissions.get(request.mod, {}).get('create', False)) or crud.update_record and session.user.access_levels.permissions.get(request.mod, {}).get('update', False) %}
            if (false) {
                // has unsaved
                Swal.fire({
                    type: 'warning',
                    title: 'Unsaved {{ module_name | singularize }} Changes',
                    text: 'Data will be lost if you continue',
                    showCancelButton: true,
                    focusCancel: true,
                    confirmButtonText: 'Continue'
                }).then((result) => {
                    if (result.value) {
                        // toggle back
                    } else {
                        // determine crud origin (add/details)

                        // $dom.crud.add.find('form [data-form-dynamic]').remove();
                        // $.each($dom.crud.add.find('[data-ajax-select-target]'), function(i, v) {
                        //     if (isDefined($(v)[0].selectize)) {
                        //         $(v)[0].selectize.setValue('');
                        //     }
                        // })
                        // $dom.crud.add.find('form').resetCustom();
                        $dom.datatables.records.reload('ignore unsaved');
                    }
                });
            } else {
                $dom.datatables.records.reload('default');
            }
            {% else %}
                $dom.datatables.records.reload('safe');
            {% endif %}

        });

        {% if crud.create and session.user.access_levels.permissions.get(request.mod, {}).get('create', False) %}
        $dom.document.on('click', '[data-crud-toggle="add"]', function() {
            $dom.crud.add.find('form').resetCustom();
            // $dom.crud.add.find('input[type!="hidden"]:not(".hidden"), select:not(".hidden"), textarea:not(".hidden")').first().trigger('focus');
        });
        {% endif %}

        {% if crud.read.one %}
        $dom.document.on('click', '[data-crud-toggle="details"]', function(e) {
            let _id = $(this).attr('data-record-id') || $dom.datatables.records.row($(this).closest('tr')).id();
            let name = $(this).html();
            let content;

            window.history.pushState('details', '{{ module_name }} Details', '/{{ module_name.lower().replace(" ", "_") }}/' + _id);

            $.get('{{ crud.read.one.url }}'.replace('placeholder', _id), function() {
            })
            .done(function(response) {
                $dom.crud.details.find('.breadcrumb-item.active').html(name);
                $dom.crud.details.find('.card-header:first > .card-title').html(name);
                $dom.crud.details.find('.card-body:first > form').html(response);
                $dom.crud.details.find('.card-body:first > form').append('<button type="submit" class="invisible"></button>');
                setTimeout(function() {
                    $.each($dom.crud.details.find('.card-body:first > form [data-ajax-select-target]'), function(i, s) {
                        $(s).ajaxDropdown();
                    });
                }, 250);
            });
        });
        {% endif %}

        {% if crud.delete and session.user.access_levels.permissions.get(request.mod, {}).get('delete', False) %}
        $dom.document.on('click', '[data-crud="delete"]', function() {
            _id = $(this).attr('data-delete-target');
            if (isDefined(_id)) {
                Swal.fire({
                    type: 'warning',
                    title: 'Delete {{ module_name|singularize }}?',
                    text: 'This action cannot be undone',
                    showCancelButton: true,
                    focusCancel: true,
                    confirmButtonText: 'Yes'
                }).then((result) => {
                    if (result.value) {
                        $.get('{{ crud.delete.one.url }}'.replace('placeholder', _id), function() {
                        })
                        .done(function(response) {
                            if (isDefined(response.success) && response.success) {
                                $dom.datatables.records.reload('delete {{ module_name|singularize }}');
                            }
                            else {
                                Swal.fire('Error', response.error, 'error');
                            }
                        })
                        .fail(function() {
                            Swal.fire('Error', 'Server Error', 'error');
                        });
                    }
                });
            }
        });
        {% endif %}

        {% if crud.create and session.user.access_levels.permissions.get(request.mod, {}).get('create', False) %}
        $dom.document.on('submit', '[data-crud="add"] form', function(e) {
            e.preventDefault();
            let $form = $(this);
            $.post($form.attr('action'), $form.serialize(), function() {})
            .done(function(response) {
                if (isDefined(response.success) && response.success) {
                    Swal.fire({
                        title: 'Successfully Added {{ module_name|singularize }}',
                        text: '',
                        type: 'success'
                    })
                    .then(function() {
                        Swal.fire({
                            title: 'Next Action?',
                            text: '',
                            type: 'question',
                            confirmButtonText: 'Add More',
                            showCancelButton: true,
                            cancelButtonText: 'View Records',
                            focusCancel: true
                        })
                        .then((result) => {
                            if (result.value) {
                                $dom.crud.add.resetCustom();
                            }
                            else if (result.dismiss) {
                                $('a[data-crud-toggle="records"]:first').trigger('click');
                            }
                        });
                    });
                }
                else {
                    Swal.fire('Error', response.error, 'error');
                }
            })
            .always(function() {
                $dom.crud.add.find('[data-submit-form]').ladda('stop');
            })
            .fail(function() {
                Swal.fire('Error', 'Server Error', 'error');
            });
        });
        {% endif %}

        {% if crud.update_record and session.user.access_levels.permissions.get(request.mod, {}).get('update', False) %}
        $dom.document.on('submit', '[data-crud="details"] form', function(e) {
            e.preventDefault();
            let $form = $(this);
            $.post($form.attr('action'), $form.serialize(), function() {})
            .done(function(response) {
                if (isDefined(response.success) && response.success) {
                    Swal.fire({
                        title: 'Successfully Updated {{ module_name }}',
                        text: '',
                        type: 'success',
                        confirmButtonText: 'Continue'
                    })
                }
                else {
                    Swal.fire('Error', response.error, 'error');
                }
            })
            .always(function() {
                $dom.crud.details.find('[data-submit-form]').ladda('stop');
            })
            .fail(function() {
                Swal.fire('Error', 'Server Error', 'error');
            });
        });
        {% endif %}

        var datatable_filter_timeout = null;
        $dom.document.on('keyup mouseup input', 'input[data-datatable-filter]', function() {
            clearTimeout(datatable_filter_timeout);
            datatable_filter_timeout = setTimeout(function() {
                $dom.datatables.records.reload('search input', true);
            }, 1000)
        });

        $dom.document.on('change', 'select[data-datatable-filter]', function() {
            clearTimeout(datatable_filter_timeout);
            datatable_filter_timeout = setTimeout(function() {
                $dom.datatables.records.reload('search dropdown', true);
            }, 300)
        });

        {# SECTION: Datatable #}
        let datatable_options = {
            dom: 'rt<"row"<"col-12 col-md-4 col-xl-3"l><"col-12 col-md-8 col-xl-9"p>><"row"<"col-12 text-center"i>>',
            order: [[0, 'asc']],
            autoWidth: false,
            responsive: true,
            stateSave: true,
            serverSide: true,
            deferLoading: true,
            lengthMenu: [[10, 25, 100, -1], ['10 Records', '25 Records', '100 Records', 'All Records']],
            ajax: {
                url: '{{ crud.read.many.url }}',
                type: 'POST',
                dataType: 'json',
                data: function(d) {
                    d.search.value = $dom.crud.records.find('[data-datatable-filter="search"]').val();
                    $.each($dom.crud.records.find('[data-datatable-filter][data-datatable-filter!="search"]'), function(i, v) {
                        let index = $(v).attr('data-datatable-filter');
                        let value =$(v).val().trim();
                        if (value !== '' && isDefined(d.columns[index])) {
                            d.columns[index].search.value = value;
                        }
                    });
                    return d;
                }
            },
            columns: [
                {% block read_columns %}{% endblock %}
            ],
            rowId: '_id',
            initComplete: function() {
                $dom.crud.records.find('.dataTables_info').addClass('text-muted');
            },
            preDrawCallback: function() {

            },
            drawCallback: function() {

            }
        }
        $dom.datatables.records = $dom.tables.records.DataTable(datatable_options);

        $dom.datatables.records.reload = function(trigger, search) {
            trigger = (!isDefined(trigger)) ? 'unknown' : trigger;
            if (!isDefined($dom.datatables.records.reloading)) {
                {% if request.debug %}
                console.debug('ajax table: reloading - {0}'.format(trigger));
                {% endif %}
                $dom.datatables.records.reloading = true;
                $dom.datatables.records.ajax.reload(function() {
                    search = (!isDefined(search)) ? false : search;
                    if ((!search) && ($dom.datatables.records.rows().count() <= 0)) {
                        $('a[data-crud-toggle="empty"]:first').trigger('click');
                    } else {
                        $dom.tables.records.closest('.card').show(250);
                    }
                    setTimeout(function() {
                        delete $dom.datatables.records.reloading;
                    }, 1000);
                });
            } else {
                {% if request.debug %}
                console.debug('ajax table: deferred - {0}'.format(trigger));
                {% endif %}
            }
        }
        {# END: Datatable #}

        $dom.document.ready(function() {
            setTimeout(function() {
                {% if record %}
                    $('a[data-crud-toggle="details"]:first').trigger('click');
                {% else %}
                    $dom.datatables.records.reload('initial');
                {% endif %}
            }, 100);
        });
        {% block sub_scripts %}{% endblock %}
    </script>
{% endblock %}
